#include <machine.h>
#include "iodefine.h"
#include "sci.h"

// VAʐM֘A֐ ========================================================

void sciinit()
{
	// ~
	SCI3.SCR3.BIT.TE = 0;	// M~
	SCI3.SCR3.BIT.RE = 0;	// M~
	
	// VARg[WX^3(SCR3)̐ݒ
	SCI3.SCR3.BIT.CKE = 0;	// [00] NbN\[X͓{[[gWFl[^

	// VA[hWX^(SMR)̐ݒ
	SCI3.SMR.BIT.COM = 0;	// [h
	SCI3.SMR.BIT.CHR = 0;	// f[^8rbg
	SCI3.SMR.BIT.PE = 0;	// peB͎gpȂ
	SCI3.SMR.BIT.STOP = 0;	// 1Xgbvrbg
	SCI3.SMR.BIT.MP = 0;	// }`vZbT[h͎gpȂ
	SCI3.SMR.BIT.CKS = 0;	// [00] NbN\[X̓

	// rbg[gWX^(BRR)̐ݒ
	SCI3.BRR = 11;		// 38400bps
	
	// VAXe[^XWX^(SSR)̐ݒ
	SCI3.SSR.BIT.OER = 0;	// I[o[G[NA
	SCI3.SSR.BIT.FER = 0;	// t[~OG[NA
	SCI3.SSR.BIT.PER = 0;	// peBG[NA
	
	// Jn
	SCI3.SCR3.BIT.TE = 1;	// MJn
	SCI3.SCR3.BIT.RE = 1;	// MJn
	
	// P22/TXD[q̋@\̐ݒ
	IO.PMR1.BIT.TXD = 1;	// TXDo͒[qƂĎgp
}

char scigetc()
{
     char ch;
	 
     while ((SCI3.SSR.BYTE & 0x78) == 0);	// MƃG[̃tO܂ő҂
	 
     if(SCI3.SSR.BIT.RDRF == 1){            // ɎMł
          ch = SCI3.RDR;                  	// Mf[^i[
          return ch;
     } else {								// MɃG[
          SCI3.SSR.BYTE &= 0xc7;            // G[tÕNA
          return 0xff;						// 0xffԂ
     }
}

char *scigets(char *str)
{
	char *p, ch;
	
	p = str;
	
	while (1) {
		ch = scigetc();
		if (ch == '\r') break;
		*p++ = ch;
	}
	*p = '\0';
	
	return str;	
}

void sciputc(char ch)
{
     while (SCI3.SSR.BIT.TDRE == 0);		// Mf[^̑M܂ő҂

     SCI3.TDR = ch;						// Mf[^i[
}

void sciputs(char *str)
{
	char *p;
	
	for (p = str; *p != '\0'; p++)
		sciputc(*p);
}
